'
'  In App.xaml:
'  <Application.Resources>
'      <vm:ViewModelLocatorTemplate xmlns:vm="clr-namespace:MvvmLightDemo"
'                                   x:Key="Locator" />
'  </Application.Resources>
'  
'  In the View:
'  DataContext="{Binding Source={StaticResource Locator}, Path=ViewModelName}"
'
'  You can also use Blend to do all this with the tool's support.
'  See http://www.galasoft.ch/mvvm
'

Imports GalaSoft.MvvmLight

Namespace MvvmLightDemo.ViewModel
	''' <summary>
	''' This class contains static references to all the view models in the
	''' application and provides an entry point for the bindings.
	''' </summary>
	Public Class ViewModelLocator
		Private _main As MainViewModel
		Private _dataService As IDemoDataService

		''' <summary>
		''' Initializes a new instance of the ViewModelLocator class.
		''' </summary>
		Public Sub New()
			If ViewModelBase.IsInDesignModeStatic Then
			   _dataService = New DesignDemoDataService()
			Else
				_dataService = New DemoDataService()
			End If

			_main = New MainViewModel(_dataService)
		End Sub

		''' <summary>
		''' Gets the Main property which defines the main viewmodel.
		''' </summary>
		<System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1822:MarkMembersAsStatic", Justification := "This non-static member is needed for data binding purposes.")>
		Public ReadOnly Property Main() As MainViewModel
			Get
				Return _main
			End Get
		End Property
	End Class
End Namespace